package com.antop.controller;

import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.antop.model.LoggerInfo;
import com.antop.service.LogbackService;

@Controller
@RequestMapping(value = "/logback")
public class LogbackController {

	private final Logger logger = LoggerFactory.getLogger(getClass());

	@Autowired
	private LogbackService service;

	@RequestMapping(method = RequestMethod.GET)
	@ResponseBody
	public List<LoggerInfo> list() {
		List<LoggerInfo> list = service.inquire();

		if (logger.isDebugEnabled() == true) {
			for (LoggerInfo li : list) {
				logger.debug(li.toString());
			}
		}

		try {
			// 화면에 로딩 메세지는 보이게 딜레이 주자
			Thread.sleep(500);
		} catch (InterruptedException e) {

		}

		return list;

	}

	@RequestMapping(method = RequestMethod.POST)
	@ResponseBody
	public LoggerInfo modify(@RequestParam String name,
			@RequestParam String level) {
		logger.debug("name = {}, level={}", name, level);

		LoggerInfo li = service.changeLevel(name, level);

		logger.debug("result = {}", li);

		return li;
	}

	@RequestMapping(value = "/reset", method = RequestMethod.GET)
	@ResponseBody
	public void reset() {
		service.reset();
	}
}
