package com.antop.service.impl;

import java.util.ArrayList;
import java.util.List;

import ch.qos.logback.classic.Level;
import ch.qos.logback.classic.jmx.JMXConfiguratorMBean;
import ch.qos.logback.core.joran.spi.JoranException;

import com.antop.model.LoggerInfo;
import com.antop.service.LogbackService;

public class LogbackServiceImpl implements LogbackService {

	private JMXConfiguratorMBean mbean;

	@Override
	public List<LoggerInfo> inquire() {
		List<LoggerInfo> list = new ArrayList<LoggerInfo>();
		for (String loggerName : mbean.getLoggerList()) {
			LoggerInfo li = new LoggerInfo();
			li.setName(loggerName);
			li.setLevel(Level.toLevel(mbean.getLoggerLevel(loggerName)));

			list.add(li);
		}

		return list;
	}

	@Override
	public LoggerInfo changeLevel(String name, String levelStr) {
		Level level = Level.valueOf(levelStr);
		mbean.setLoggerLevel(name, level.toString());

		LoggerInfo li = new LoggerInfo();
		li.setName(name);
		li.setLevel(Level.toLevel(mbean.getLoggerLevel(name)));

		return li;
	}
	
	public void reset() {
		try {
			mbean.reloadDefaultConfiguration();
		} catch (JoranException e) {
			throw new RuntimeException("failed reload logback default configuration.", e);
		}
	}

	public void setMbean(JMXConfiguratorMBean mbean) {
		this.mbean = mbean;
	}

}
