$(document).ready(function () {
	// param query 에서 레벨의 셀편집에 사용되는 select 태그를 만드는 펑션
	var dropDownEditor = function (ui, arr) {
        var $cell = ui.$cell, data = ui.data, rowIndx = ui.rowIndxPage, colIndx = ui.colIndx;
        var dataCell = $.trim(data[rowIndx][colIndx]);
        var str = '';
        for (var i = 0; i < arr.length; i++) {
            if (dataCell == arr[i])
                str += '<option selected>' + arr[i] + '</option>';
            else
                str += '<option>' + arr[i] + '</option>';
        }
        
        $('<select class="level">' + str + '</select>').appendTo($cell);
    };
	
    var saveCell = function (ui) {
        var $cell = ui.$cell;
        return $cell.children().val();
    };

    // param query
	var grid = $('#grid').pqGrid({
		width : 700,
		resizable: false,
		draggable: false,
		topVisible: false,
		roundCorners: false,
		numberCell: true,
		scrollModel : {
			horizontal: false
		},
		dataModel: {
			location: 'remote',
			sorting: 'local',
			paging: 'local',
			rPP : 20,
			rPPOptions : [10, 20, 50, 100],
			dataType: 'json',
			method: 'GET',
			curPage : 1,
			getUrl: function () {
				return {
					url: 'logback'
				};
			},
			getData: function (json, textStatus, jqXHR) {
				var data = [];
				for (var i in json) {
					var l = json[i];
					
					data.push({
						name: l.name,
						level: l.level.levelStr
					});
				}
				
				return {
					data: data
				};
			}
		},
		colModel : [{
			title: 'Name',
			width : 500,
			dataIndx: 'name',
			editable: false
		}, {
			title: 'Level',
			width : 90,
			dataIndx : 'level',
			editor: function (ui) {
				var arr = ['OFF', 'ERROR', 'WARN', 'INFO', 'DEBUG', 'TRACE', 'ALL'];
				dropDownEditor(ui, arr);
			},
			getEditCellData: saveCell
		}]
	});
	
	grid.on("pqgridquiteditmode", function (evt, ui) {
        if (evt.keyCode != 27 && evt.keyCode != 9) {
            grid.pqGrid("saveEditCell");
        }
    });
	
	// 셀 편집 후 저장 이벤트
	grid.on("pqgridcellsave", function (evt, ui) {
		var row = ui.data[ui.rowIndx];
		var name = row.name;
		var level = row[ui.dataIndx];
		
		$.ajax({
			url: 'logback',
			type: 'POST',
			contentType : 'application/x-www-form-urlencoded',
			dataType: 'json',
			data: {
				name: name,
				level: level
			},
			success : function() {
				// 구현 귀찮음 -_-
			},
			error : function() {
				// 구현 귀찮음 -_-
			}
		});
    });
	
	// Reset 버튼 클릭
	$('#btnReset').click(function () {
		$.ajax({
			url: 'logback/reset',
			tyep: 'GET',
			context : $(this),
			beforeSend: function () {
				this.prop('disabled', true);
			},
			success : function() {
				grid.pqGrid('refreshDataAndView');
			},
			complete: function () {
				this.prop('disabled', false);
			}
		});
	});
	
	// Test 버튼 클릭
	$('#btnLog').click(function () {
		$.get('log.do', function (resp) {
			$('#console>p').text(resp);
		});
	});
	
});